IndoorHud = {};
    
    function IndoorHud.prerequisitesPresent(specializations)
        return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations) and SpecializationUtil.hasSpecialization(Motorized, specializations);
    end;
    
    function IndoorHud:load(savegame)
    
        
    
        self.porteG = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.porteG#index"));
        self.porteD = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.porteD#index"));
        
        self.fillLevelactuel1 = 0
        self.fillLevelactuel2 = 0
        self.fillLeveltemp = 0
        
        self.batterie = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.batterie#index"));
        setVisibility(self.batterie, false)
    
        self.testvoyant = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.testvoyant#index"));
        setVisibility(self.testvoyant, false)
        self.testvoyanttemp = 0
        
        self.ecran = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.ecran#index"));
        setVisibility(self.ecran, false)
        
        self.phare = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.phare#index"));
        setVisibility(self.phare, false)
        
        self.clignobleu1 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.clignobleu1#index"));
        setVisibility(self.clignobleu1, false)
        self.clignobleutemp1 = 0
        
        self.clignobleu2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.clignobleu2#index"));
        setVisibility(self.clignobleu2, false)
        self.clignobleutemp2 = 0
        
        self.feuroute = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.feuroute#index"));
        setVisibility(self.feuroute, false)
        
        self.feuorange1 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.feuorange1#index"));
        setVisibility(self.feuorange1, false)
        
        self.feuorange2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.feuorange2#index"));
        setVisibility(self.feuorange2, false)        

        self.prechauffage = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.prechauffage#index"));
        setVisibility(self.prechauffage, false)    

        self.Bluelight = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Bluelight#index"));
        setVisibility(self.Bluelight, false)    

        self.Spot = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Spot#index"));
        setVisibility(self.Spot, false)            
        
        self.Bluelightp = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Bluelightp#index"));
        setVisibility(self.Bluelightp, false)    

        self.Spotp = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Spotp#index"));
        setVisibility(self.Spotp, false)        
        
        self.setHudValue = IndoorHud.setHudValue;
    
        self.indoorHud = {};
        self.indoorHud.fillLevel1 = IndoorHud.loadValue(self, self.xmlFile, "fillLevel1");
        self.indoorHud.fillLevel2 = IndoorHud.loadValue(self, self.xmlFile, "fillLevel2");
        self.indoorHud.fillLevel3 = IndoorHud.loadValue(self, self.xmlFile, "fillLevel3");
        
        self.FumebennePS = {}; 
        local psName = "vehicle.Fumebenne";
        local defaultPs = "defaultParticles.i3d";
        Utils.loadParticleSystem(self.xmlFile, self.FumebennePS, psName, self.components, false, defaultPs, self.baseDirectory);
        
        self.FumebennemovPS = {}; 
        local psName = "vehicle.Fumebennemov";
        local defaultPs = "defaultParticles.i3d";
        Utils.loadParticleSystem(self.xmlFile, self.FumebennemovPS, psName, self.components, false, defaultPs, self.baseDirectory);
    
    end;

    function IndoorHud:loadValue(self.xmlFile, name)
        local numbers = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.indoorHudt282."..name.."#numbers"));
        local animName = getXMLString(self.xmlFile, "vehicle.indoorHudt282."..name.."#animName");
    
        if numbers ~= nil or animName ~= nil then
            local precision = nil;
            local numChilds = nil;
            local maxValue = nil;
            if numbers ~= nil then
                precision = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.indoorHudt282."..name.."#precision"), 1);
                numChilds = getNumOfChildren(numbers);
                if numChilds-precision <= 0 then
                    print("Warning: Not enough number meshes in '"..self.configFileName.."'");
                end;
                numChilds = numChilds - precision;
                maxValue = (10 ^ (numChilds)) - 1/(10^precision); -- e.g. max with 2 childs and 1 float -> 10^2 - 1/10 -> 99.9 -> makes sure that display doesn't show 00.0 if value is 100
            end;
    
            local hud = {numbers=numbers, animName=animName, lastNormValue=0, lastValue=-1, precision=precision, maxValue=maxValue, numChilds=numChilds};
            self:setHudValue(hud, 0, 0);
            return hud;
        end;
        return nil;
    end;
    
    function IndoorHud:delete()
        Utils.deleteParticleSystem(self.FumebennePS);
        Utils.deleteParticleSystem(self.FumebennemovPS);
    end;
    
    function IndoorHud:mouseEvent(posX, posY, isDown, isUp, button)
    end;
    
    function IndoorHud:keyEvent(unicode, sym, modifier, isDown)
    end;
    
    function IndoorHud:update(dt)
    end; 
    
    function IndoorHud:updateTick(dt)
    
    self.fillLeveltemp = self.fillLeveltemp + dt
    if self.fillLeveltemp < 50 then
        self.fillLevelactuel1 = self.fillLevel 
    end;
    if self.fillLeveltemp > 100 then
        self.fillLevelactuel2 = self.fillLevel 
    end;
    
    
    if self.fillLevelactuel2 > self.fillLevelactuel1 then
        Utils.setEmittingState(self.FumebennePS, true)
    else
        Utils.setEmittingState(self.FumebennePS, false)
    end;
    
    
    local minimumfill  = self.capacity*0.1
    if self.fillLevel > minimumfill then
        if self.movingDirection == 1 or self.movingDirection == -1 then
            Utils.setEmittingState(self.FumebennemovPS, true)
        else
            Utils.setEmittingState(self.FumebennemovPS, false)
        end;
    else
        Utils.setEmittingState(self.FumebennemovPS, false)
    end;
    
    if self.fillLeveltemp >= 500 then
        self.fillLeveltemp = 0
    end;

    local xSpot,ySpot,zSpot = getRotation(self.Spotp);
    local xBluelight,yBluelight,zBluelight = getRotation(self.Bluelightp);

    self.clignobleutemp1 = self.clignobleutemp1 + dt
    if self.clignobleutemp1 < 500 then
        setVisibility(self.clignobleu1, true)
    else
        setVisibility(self.clignobleu1, false)
    end;
        
    if self.clignobleutemp1 >= 1000 then
        self.clignobleutemp1 = 0
    end;

    self.clignobleutemp2 = self.clignobleutemp2 + dt
    if self.clignobleutemp2 < 450 then
        setVisibility(self.clignobleu2, true)
    else
        setVisibility(self.clignobleu2, false)
    end;
    
    if self.clignobleutemp2 >= 900 then
        self.clignobleutemp2 = 0
    end;

    if ySpot > 0.02 and self.isMotorStarted then 
        setVisibility(self.Spot, true)
    else
        setVisibility(self.Spot, false)
    end;
    
    if yBluelight > 0.02 and self.isMotorStarted then 
        setVisibility(self.Bluelight, true)
    else
        setVisibility(self.Bluelight, false)
    end;
    
    if self.isMotorStarted then
        setVisibility(self.batterie, false)
        self.testvoyanttemp  =  self.testvoyanttemp + dt
        if self.testvoyanttemp < 2000 then
            setVisibility(self.testvoyant, true)
        else
            setVisibility(self.testvoyant, false)
        end;
        setVisibility(self.feuorange1, true)
        setVisibility(self.feuorange2, true)
        setVisibility(self.ecran, true)
        setVisibility(self.phare, true)
        setVisibility(self.feuroute, true)
    else
        setVisibility(self.testvoyant, false)
        setVisibility(self.feuorange1, false)
        setVisibility(self.feuorange2, false)
        setVisibility(self.ecran, false)
        setVisibility(self.phare, false)
        setVisibility(self.feuroute, false)
        self.testvoyanttemp = 0
    end;
    if self.ignitionMode ~= nil then
        if self.heater["currentTime"] > 0 and self.ignitionMode == ManualIgnition.STAGE_PRE_HEAT then
            setVisibility(self.prechauffage, true)
            setVisibility(self.batterie, true)
        else
            setVisibility(self.prechauffage, false)
        end;
    end;
            if self.indoorHud.fillLevel1 ~= nil and self.fillLevel ~= nil and self.getCapacity ~= nil and self:getCapacity() ~= 0 then
                self:setHudValue(self.indoorHud.fillLevel1, self.fillLevel*2.385, self:getCapacity());
            end;
            if self.indoorHud.fillLevel2 ~= nil and self.fillLevel ~= nil and self.getCapacity ~= nil and self:getCapacity() ~= 0 then
                self:setHudValue(self.indoorHud.fillLevel2, self.fillLevel*2.385, self:getCapacity());
            end;
            if self.indoorHud.fillLevel3 ~= nil and self.fillLevel ~= nil and self.getCapacity ~= nil and self:getCapacity() ~= 0 then
                self:setHudValue(self.indoorHud.fillLevel3, self.fillLevel*2.385, self:getCapacity());
            end;
    end;
    
    function IndoorHud:draw()
    end;
    
    function IndoorHud:setHudValue(hud, value, maxValue)
        if hud.numbers ~= nil then
            if math.abs(hud.lastValue-value) > 1/(10^(hud.precision+1)) then
                local displayedValue = math.min(hud.maxValue, math.max(0, value));
                local speed = tonumber(string.format("%."..hud.precision.."f", displayedValue));
                Utils.setNumberShaderByValue(hud.numbers, speed, hud.precision, true);
                hud.lastValue = value;
            end;
        end;
        if hud.animName ~= nil then
            local normValue = Utils.round(value/maxValue, 3);
            if maxValue == 0 then
                normValue = 0;
            end;
            if math.abs(hud.lastNormValue - normValue) > 0.01 then
                self:setAnimationTime(hud.animName, normValue, true);
                hud.lastNormValue = normValue;
            end;
        end;
    end;
